// ======================================================================
//
// rect.h
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef RECT_H
#define RECT_H

// ======================================================================

#include "point.h"

// ======================================================================

struct Rect
{
	union
	{
		int x0;
		int left;
	};

	union
	{
		int y0;
		int top;
	};

	union
	{
		int x1;
		int right;
	};

	union
	{
		int y1;
		int bottom;
	};

	bool isInInclusive(int x, int y) const;
	bool isInExclusive(int x, int y) const;
};

// ======================================================================

inline bool Rect::isInInclusive(int x, int y) const
{
	return (x >= x0 && y >= y0 && x <= x1 && y <= y1);
}

inline bool Rect::isInExclusive(int x, int y) const
{
	return (x > x0 && y > y0 && x < x1 && y < y1);
}

// ======================================================================

#endif
